Bug 596009 - Possible ext4 anomalies
Possible ext4 anomalies
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
13
All Linux
low Severity urgent
: ---
: ---
Assigned To: Eric Sandeen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-05-26 02:23 EDT by George R. Goffe
Modified: 2011-02-15 16:57 EST (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-02-15 16:57:18 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description George R. Goffe 2010-05-26 02:23:06 EDT
Description of problem:

I have had my FC12 system installed since February this year and have
experienced this particular problem twice so far. The problem does NOT
happen frequently... Just long enough for me to become complacent that
it was a fluke.

Files in /root have become empty, 141 of them this time. Their update
dates are all the same, about 2 minutes before I noticed the problem
this time.

Version-Release number of selected component (if applicable):

This has happened with older kernels as well but I do not know their version information.

Current kernel=2.6.32.12-115.fc12.i686.PAE #1 SMP Fri Apr 30 20:14:08 UTC 2010 i686 i686 i386 GNU/Linux

How reproducible:

This has happened twice since February 2010.

Steps to Reproduce:
1.Unknown
2.
3.
  
Actual results:

This time, 141 files have become 0 length.

Expected results:

Not this.

Additional info:

I am EXTREMELY reluctant to claim that this is anyone's programming error. Are there traps that can be placed that would give more information? The only way I know to cause this problem is by taking specific steps like "cat /dev/null > filename" or editing the files but just these specific files, deleting all their data and then saving the file. I assure you that I would not do such a thing. None of these files have anything specific in common except that they're all in /root (same as last time) AND fstype = ext4; OS=FC12.

The system is more up to date than the first failure and there are different rpms as well.

Possible clue? I have a script in /root that I make a soft link in / named poweroff (cd /;ln -s /root/poweroff .). I can make the link and reboot the system and the link will disappear.
Comment 1 Eric Sandeen 2010-06-11 12:44:50 EDT
Have you had crashes or powerlosses before you saw this happen?  Or the machine has been up this whole time and you suddenly have the content lost?

What does poweroff do?  :)

Does the root fs fsck cleanly?  (touch /.forcefsck will make it check next boot, IIRC)
Comment 2 George R. Goffe 2010-06-11 15:31:00 EDT
No crashes or power losses.

I'll give your /.forcefsck trick and reboot in a while. Does this work on all file systems?

THANKS!
Comment 3 Bug Zapper 2010-11-03 10:11:23 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 George R. Goffe 2010-11-04 16:20:09 EDT
Howdy,

I'd like to leave this open just in case. I'll be migrating to FC13 in the near future. So far, the problem has not happened again.

If you MUST close it then please feel free to do so.

Thanks,

George...
Comment 5 Jacek Pliszka 2010-12-02 15:39:16 EST
Hi!

I just got the same error in F14.  My wife was using OpenOffice writer - she saves regularly. 

Then suddenly we had power outage.

After it the document she was working on for the last 5 hours and was saving regularly was gone and empty.

OpenOffice writer was not able to recover it.

Before F14 we used ext3 for /home - never had problems like this - OO always was able to recover.

With F14 we are using ext4 - I guess this might be ext4 bug.
Comment 6 George R. Goffe 2010-12-09 19:16:21 EST
Howdy,

I have not seen this problem other than the two times on FC12. I have one system at FC12 and one at FC14. I'll keep my eyes on what's going on on this system that might provide clues to this behavior and, of course, report them immediately.

Is this the right place for FC14 bugs?

George...
Comment 7 Eric Sandeen 2010-12-13 13:04:15 EST
ext3 essentially syncs every 5s - data=ordered (default) + 5s journal commit pushes file data out more often than "normal"

It is most likely that the application is not doing proper data integrity management... even in the case of a manual save, it matters what OO is doing during periodic saves, etc.

I'm not aware of any deficiencies in ext4's fsync/data integrity handling...

In each specific case here it would be good to do something like strace OO, and see what file IO calls it's doing (writes, truncates, opens, closes, renames, fsyncs, etc...)

-Eric
Comment 8 Eric Sandeen 2011-02-11 18:21:08 EST
George, are you still seeing these issues?  If not I don't know where to go with this bug...

Jacek, losing buffered data after a power loss sounds like a different issue, and more likely related to OO doing something bad with data integrity.

I'll probably close this bug unless the mystery George reported is still being mysterious...
Comment 9 George R. Goffe 2011-02-11 20:28:38 EST
Eric,

I think we can close this one. I have not (so far) seen any problems like this. I'm on fc14 now... It's rough... KDE/X11 are having serious problems... a whole slew of other X11 stuff's failing... I use startx > startx.log 2>&1 and it's horrible... + X11 dumps core when you exit KDE... I have not made many bugs yet... but will.

Regards and thanks for your patience.

George...
Comment 10 Eric Sandeen 2011-02-15 16:57:18 EST
Current release seems to work, so closing.

Note You need to log in before you can comment on or make changes to this bug.